diff --git a/tools/lib/traceevent/Documentation/libtraceevent-file_endian.txt b/tools/lib/traceevent/Documentation/libtraceevent-file_endian.txt
index 5b8e01235eda..2b763aaf9c6b 100644
--- a/tools/lib/traceevent/Documentation/libtraceevent-file_endian.txt
+++ b/tools/lib/traceevent/Documentation/libtraceevent-file_endian.txt
@@ -3,7 +3,7 @@ libtraceevent(3)
 
 NAME
 ----
-tep_is_file_bigendian,tep_set_file_bigendian - Get / set the endianess of the 
+tep_file_bigendian,tep_set_file_bigendian - Get / set the endianess of the 
 raw data, being accessed by the tep handler. 
 
 SYNOPSIS
@@ -17,13 +17,13 @@ enum *tep_endian* {
 	TEP_BIG_ENDIAN
 };
 
-int *tep_is_file_bigendian*(struct tep_handle pass:[*]_tep_);
+int *tep_file_bigendian*(struct tep_handle pass:[*]_tep_);
 void *tep_set_file_bigendian*(struct tep_handle pass:[*]_tep_, enum tep_endian _endian_);
 
 --
 DESCRIPTION
 -----------
-The _tep_is_file_bigendian()_ function returns the endianess of the raw data,
+The _tep_file_bigendian()_ function returns the endianess of the raw data,
 being accessed by the tep handler. The _tep_ argument is trace event parser context.
 
 The _tep_set_file_bigendian()_ set the endianess of raw data, the being accessed 
@@ -36,7 +36,7 @@ The _endian_ argument is the endianess:
 --
 RETURN VALUE
 ------------
-The _tep_is_file_bigendian()_ function returns _TEP_LITTLE_ENDIAN_ or _TEP_BIG_ENDIAN_.
+The _tep_file_bigendian()_ function returns _TEP_LITTLE_ENDIAN_ or _TEP_BIG_ENDIAN_.
 
 EXAMPLE
 -------
@@ -48,7 +48,7 @@ struct tep_handle *tep = tep_alloc();
 ...
 	tep_set_file_bigendian(tep, TEP_LITTLE_ENDIAN);
 ...
-	if (TEP_BIG_ENDIAN == tep_is_file_bigendian(tep)) {
+	if (TEP_BIG_ENDIAN == tep_file_bigendian(tep)) {
 		/* The raw data is in big endian */
 	} else {
 		/* The raw data is in little endian */
diff --git a/tools/lib/traceevent/Documentation/libtraceevent.txt b/tools/lib/traceevent/Documentation/libtraceevent.txt
index e2b4ca615809..1100240a8a29 100644
--- a/tools/lib/traceevent/Documentation/libtraceevent.txt
+++ b/tools/lib/traceevent/Documentation/libtraceevent.txt
@@ -129,7 +129,7 @@ Command and task related APIs:
 Endian related APIs:
 	int *tep_host_bigendian*(void);
 	unsigned long long *tep_read_number*(struct tep_handle pass:[*]_tep_, const void pass:[*]_ptr_, int _size_);
-	int *tep_is_file_bigendian*(struct tep_handle pass:[*]_tep_);
+	int *tep_file_bigendian*(struct tep_handle pass:[*]_tep_);
 	void *tep_set_file_bigendian*(struct tep_handle pass:[*]_tep_, enum tep_endian _endian_);
 	int *tep_is_host_bigendian*(struct tep_handle pass:[*]_tep_);
 	void *tep_set_host_bigendian*(struct tep_handle pass:[*]_tep_, enum tep_endian _endian_);
diff --git a/tools/lib/traceevent/event-parse-api.c b/tools/lib/traceevent/event-parse-api.c
index 39e0fca2d9a2..884b8585d22e 100644
--- a/tools/lib/traceevent/event-parse-api.c
+++ b/tools/lib/traceevent/event-parse-api.c
@@ -201,13 +201,13 @@ void tep_set_page_size(struct tep_handle *pevent, int _page_size)
 }
 
 /**
- * tep_is_file_bigendian - get if the file is in big endian order
+ * tep_file_bigendian - get if the file is in big endian order
  * @pevent: a handle to the tep_handle
  *
  * This returns if the file is in big endian order
  * If @pevent is NULL, 0 is returned.
  */
-int tep_is_file_bigendian(struct tep_handle *pevent)
+int tep_file_bigendian(struct tep_handle *pevent)
 {
 	if (pevent)
 		return pevent->file_bigendian;
diff --git a/tools/lib/traceevent/event-parse.h b/tools/lib/traceevent/event-parse.h
index ff74dc392268..262abe3c6c9e 100644
--- a/tools/lib/traceevent/event-parse.h
+++ b/tools/lib/traceevent/event-parse.h
@@ -553,7 +553,7 @@ int tep_get_long_size(struct tep_handle *pevent);
 void tep_set_long_size(struct tep_handle *pevent, int long_size);
 int tep_get_page_size(struct tep_handle *pevent);
 void tep_set_page_size(struct tep_handle *pevent, int _page_size);
-int tep_is_file_bigendian(struct tep_handle *pevent);
+int tep_file_bigendian(struct tep_handle *pevent);
 void tep_set_file_bigendian(struct tep_handle *pevent, enum tep_endian endian);
 int tep_is_host_bigendian(struct tep_handle *pevent);
 void tep_set_host_bigendian(struct tep_handle *pevent, enum tep_endian endian);
diff --git a/tools/lib/traceevent/plugin_kvm.c b/tools/lib/traceevent/plugin_kvm.c
index 637be7c18476..388a78a6035f 100644
--- a/tools/lib/traceevent/plugin_kvm.c
+++ b/tools/lib/traceevent/plugin_kvm.c
@@ -389,7 +389,7 @@ static int kvm_mmu_print_role(struct trace_seq *s, struct tep_record *record,
 	 * We can only use the structure if file is of the same
 	 * endianess.
 	 */
-	if (tep_is_file_bigendian(event->pevent) ==
+	if (tep_file_bigendian(event->pevent) ==
 	    tep_is_host_bigendian(event->pevent)) {
 
 		trace_seq_printf(s, "%u q%u%s %s%s %spae %snxe %swp%s%s%s",